=== debian/changelog ===
ga (5.9.2-2) unstable; urgency=medium

  * Team upload.
  * refresh build against current MPI libraries

 -- Drew Parsons <dparsons@debian.org>  Tue, 28 Oct 2025 02:12:03 +0100

ga (5.9.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Sun, 11 May 2025 13:55:07 +0200

ga (5.9.1-2) unstable; urgency=medium

  * Team upload.
  * ensure ga is rebuilt for the version of mpich (really4.2.1)
    targetted for trixie

 -- Drew Parsons <dparsons@debian.org>  Fri, 09 May 2025 12:11:03 +0200
